//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     MediumVioletRed
#property indicator_color2     MediumVioletRed
#property indicator_color3     DeepSkyBlue
#property indicator_color4     DeepSkyBlue
#property indicator_color5     Silver
#property indicator_width1     2
#property indicator_width3     2
#property indicator_width5     2
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    ForcePeriod      = 5;
extern int    ForceMaMethod    = 0;
extern int    ForcePrice       = 0;
extern int    SmoothPeriod     = 21;
extern int    SmoothMethod     = 4;
extern bool   HistogramOnSlope = false;

extern string SmoothMethods    = "";
extern string __0              = "SMA";
extern string __1              = "EMA";
extern string __2              = "SSMA";
extern string __3              = "LWMA";
extern string __4              = "LSMA";

extern bool   alertsOn         = false;
extern bool   alertsOnSlope    = false;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double forces[];
double force[];
double Upa[];
double Upb[];
double Dna[];
double Dnb[];
double trend[];
double slope[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
  {
   IndicatorBuffers(8);
   SetIndexBuffer(0,Dna);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dnb);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Upa);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,Upb);   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,forces);
   SetIndexBuffer(5,force);
   SetIndexBuffer(6,trend);
   SetIndexBuffer(7,slope);
   SetLevelValue(0,0);
   
       //
       //
       //
       //
       //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
       
       //
       //
       //
       //
       //
       
     IndicatorShortName(timeFrameToString(timeFrame)+"  force smoothed with "+getAverageName(SmoothMethod)+" ("+SmoothPeriod+","+ForcePeriod+")");
     SetIndexLabel(0,"");
     SetIndexLabel(1,"");
     SetIndexLabel(2,"");
     SetIndexLabel(3,"");
     SetIndexLabel(4,"");
     SetIndexLabel(5,"");
     SetIndexLabel(6,"");
     SetIndexLabel(7,"");
return(0);
}

int deinit() { return(0); }
  
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Dna[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      { 
          force[i] = Volume[i] * (iMA(NULL,0,ForcePeriod,0,ForceMaMethod,ForcePrice,i) - iMA(NULL,0,ForcePeriod,0,ForceMaMethod,ForcePrice,i+1));
          forces[i]= iCustomMA(force[i],SmoothPeriod,SmoothMethod,i); 
          Dna[i]   = EMPTY_VALUE;
          Dnb[i]   = EMPTY_VALUE;
          Upa[i]   = EMPTY_VALUE;
          Upb[i]   = EMPTY_VALUE;
          trend[i] = trend[i+1];
          slope[i] = slope[i+1];
          
          if (forces[i] > 0)           trend[i] =  1;
          if (forces[i] < 0)           trend[i] = -1;
          if (forces[i] > forces[i+1]) slope[i] =  1;
          if (forces[i] < forces[i+1]) slope[i] = -1;
               
          if (HistogramOnSlope)
          {
             if (trend[i]== 1 && slope[i] == 1) Upa[i] = forces[i];
             if (trend[i]== 1 && slope[i] ==-1) Upb[i] = forces[i];
             if (trend[i]==-1 && slope[i] ==-1) Dna[i] = forces[i];
             if (trend[i]==-1 && slope[i] == 1) Dnb[i] = forces[i];
          }
          else
          {                  
             if (trend[i]== 1) Upa[i] = forces[i];
             if (trend[i]==-1) Dna[i] = forces[i];
          }         
      }
    manageAlerts();
    return(0);
    }   

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         forces[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ForcePeriod,ForceMaMethod,ForcePrice,SmoothPeriod,SmoothMethod,4,y);
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ForcePeriod,ForceMaMethod,ForcePrice,SmoothPeriod,SmoothMethod,6,y);
         slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",ForcePeriod,ForceMaMethod,ForcePrice,SmoothPeriod,SmoothMethod,7,y);
         Dna[i]    = EMPTY_VALUE;
         Dnb[i]    = EMPTY_VALUE;
         Upa[i]    = EMPTY_VALUE;
         Upb[i]    = EMPTY_VALUE;

         //
         //
         //
         //
         //
     
         }
         for (i=limit;i>=0;i--)
         {
            if (HistogramOnSlope)
            {
             if (trend[i]== 1 && slope[i] == 1) Upa[i] = forces[i];
             if (trend[i]== 1 && slope[i] ==-1) Upb[i] = forces[i];
             if (trend[i]==-1 && slope[i] ==-1) Dna[i] = forces[i];
             if (trend[i]==-1 && slope[i] == 1) Dnb[i] = forces[i];
            }
            else
            {                  
             if (trend[i]== 1) Upa[i] = forces[i];
             if (trend[i]==-1) Dna[i] = forces[i];
          }                           
   }
manageAlerts();
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workPrices[];
double workResult[];
int    r;

double iCustomMA(double price, int period, int method, int i)
{
   if (ArraySize(workPrices)!= Bars) ArrayResize(workPrices,Bars);
            r = Bars-i-1;
   workPrices[r] = price;

   //
   //
   //
   //
   //
   
      switch(method)
      {
         case  0: return(iSma(price,period,i));
         case  1: return(iEma(price,period,i));
         case  2: return(iSmma(price,period,i));
         case  3: return(iLwma(price,period,i));
         case  4: return(iLsma(price,period,i));
      }
   return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iSma(double price, double period, int i)
{
   double sum = 0;
   for(int k=0; k<period && (r-k)>=0; k++) sum += workPrices[r-k];  
   if (k!=0)
         return(sum/k);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iEma(double price, double period, int i)
{
   if (ArraySize(workResult)!= Bars) ArrayResize(workResult,Bars);
   double alpha = 2.0 / (1.0+period);
          workResult[r] = workResult[r-1]+alpha*(price-workResult[r-1]);
   return(workResult[r]);
}
//
//
//
//
//

double iSmma(double price, double period, int i)
{
   if (ArraySize(workResult)!= Bars) ArrayResize(workResult,Bars);
   if (i>=(Bars-period))
   {
      double sum = 0; 
         for(int k=0; k<period && (r-k)>=0; k++) sum += workPrices[r-k];  
         if (k!=0)
               workResult[i] = sum/k;
         else  workResult[i] = EMPTY_VALUE;
   }      
   else   workResult[r] = (workResult[r-1]*(period-1)+price)/period;
   return(workResult[r]);
}

//
//
//
//
//

double iLwmaprices[][3];
double iLwma(double price, double period, int i,int forValue=0)
{
   if (ArrayRange(iLwmaprices,0)!= Bars) ArrayResize(iLwmaprices,Bars);
   
   //
   //
   //
   //
   //
   
   iLwmaprices[r][forValue] = price;
      double sum  = 0;
      double sumw = 0;

      for(int k=0; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*iLwmaprices[r-k][forValue];  
      }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//
//
//
//
//

double iLsma(double price, double period, int i)
{
   return(3.0*iLwma(price,period,i)-2.0*iSma(price,period,i));
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string methodNames[] = {"SMA","EMA","SMMA","LWMA","LSMA"};
string getAverageName(int& method)
{
   method=MathMax(MathMin(method,4),0); return(methodNames[method]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      //
      //
      //
      //
      //
      
      if (alertsOnSlope)
      {
         if (slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] == 1) doAlert(whichBar,"slope changed to up");
            if (slope[whichBar] ==-1) doAlert(whichBar,"slope changed to down");
         }         
      }
      else
      {
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1) doAlert(whichBar,"crossed zero line up");
            if (trend[whichBar] ==-1) doAlert(whichBar,"crossed zero line down");
         }         
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Force oscillator ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Force"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}